<template>
  <v-layout justify-center text-xs-center>
    <v-flex xs12 class="upload">
      <div v-if="files.length">
        <v-container fluid grid-list-xs>
          <v-layout row wrap text-xs-left justify-center>
            <v-flex
              v-for="file in files"
              :key="file.id"
              xs12
              sm8
              md5
              lg4
              xl2
              class="pa-1"
            >
              <v-card class="primary darken-1 flexcard">
                <v-card-text>
                  <v-layout column justify-space-between fill-height>
                    <v-flex>
                      <span
                        class="white--text"
                        style="overflow-wrap: break-word;"
                      >
                        <span class="font-weight-bold">Name:</span>
                        {{ file.name }}
                      </span>
                    </v-flex>
                    <v-flex>
                      <span class="grow white--text">
                        <span class="font-weight-bold align-end">Size:</span>
                        {{ getFilesize(file.size) }}
                      </span>
                    </v-flex>
                  </v-layout>
                </v-card-text>
                <v-card-actions>
                  <v-layout row justify-end>
                    <v-btn
                      fab
                      small
                      color="error"
                      class="ma-2"
                      @click.prevent="remove(file)"
                    >
                      <v-icon dark>delete</v-icon>
                    </v-btn>
                  </v-layout>
                </v-card-actions>
              </v-card>
            </v-flex>
          </v-layout>
        </v-container>

        <label
          v-ripple
          for="file"
          class="v-btn"
          :class="{
            white: dark,
            'black--text': dark,
            black: !dark,
            'white--text': !dark
          }"
          >Select more files</label
        >
        <span class="text-weight-bold headline">or</span>
        <slot></slot>
      </div>

      <v-layout v-else justify-center>
        <v-card-text class="justify-center">
          <span class="headline">
            Drop files anywhere to upload
            <br />
            <span class="font-weight-bold">or</span>
            <br />
          </span>

          <label
            v-ripple
            for="file"
            class="v-btn"
            :class="{
              white: dark,
              'black--text': dark,
              black: !dark,
              'white--text': !dark
            }"
            >Select Files</label
          >
        </v-card-text>
      </v-layout>
    </v-flex>

    <div v-show="$refs.upload && $refs.upload.dropActive" class="drop-active">
      <h3>Drop files to upload</h3>
    </div>

    <keep-alive>
      <file-upload
        name="file"
        :multiple="true"
        :drop="true"
        :drop-directory="true"
        :value="files"
        accept=".csv"
        ref="upload"
        @input="inputUpdate"
      ></file-upload>
    </keep-alive>
  </v-layout>
</template>

<script>
import { mapState } from "vuex";
import filesize from "filesize";
import FileUpload from "vue-upload-component";

export default {
  components: {
    FileUpload
  },
  methods: {
    getFilesize(size) {
      return filesize(size);
    },
    inputUpdate(files) {
      this.$store.commit("updateFiles", files);
    },
    remove(file) {
      this.$refs.upload.remove(file);
    }
  },
  computed: {
    ...mapState(["files", "dark"])
  }
};
</script>

<style>
.drop-active {
  top: 0;
  bottom: 0;
  right: 0;
  left: 0;
  position: fixed;
  z-index: 9999;
  opacity: 0.6;
  text-align: center;
  background: #000;
}
.drop-active h3 {
  margin: -0.5em 0 0;
  position: absolute;
  top: 50%;
  left: 0;
  right: 0;
  -webkit-transform: translateY(-50%);
  -ms-transform: translateY(-50%);
  transform: translateY(-50%);
  font-size: 40px;
  color: #fff;
  padding: 0;
}

.flexcard {
  display: flex;
  flex-direction: column;
}
</style>
